/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-jsk-rviz-plugins-1.0.24-0quantal-20150916-0045/msg/PictogramArray.msg
 *
 */


#ifndef JSK_RVIZ_PLUGINS_MESSAGE_PICTOGRAMARRAY_H
#define JSK_RVIZ_PLUGINS_MESSAGE_PICTOGRAMARRAY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <jsk_rviz_plugins/Pictogram.h>

namespace jsk_rviz_plugins
{
template <class ContainerAllocator>
struct PictogramArray_
{
  typedef PictogramArray_<ContainerAllocator> Type;

  PictogramArray_()
    : header()
    , pictograms()  {
    }
  PictogramArray_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , pictograms(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector< ::jsk_rviz_plugins::Pictogram_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::jsk_rviz_plugins::Pictogram_<ContainerAllocator> >::other >  _pictograms_type;
  _pictograms_type pictograms;




  typedef boost::shared_ptr< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PictogramArray_

typedef ::jsk_rviz_plugins::PictogramArray_<std::allocator<void> > PictogramArray;

typedef boost::shared_ptr< ::jsk_rviz_plugins::PictogramArray > PictogramArrayPtr;
typedef boost::shared_ptr< ::jsk_rviz_plugins::PictogramArray const> PictogramArrayConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_rviz_plugins

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'jsk_rviz_plugins': ['/tmp/buildd/ros-hydro-jsk-rviz-plugins-1.0.24-0quantal-20150916-0045/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bfdafbfcdf121aed91dae673b47ae3fe";
  }

  static const char* value(const ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xbfdafbfcdf121aedULL;
  static const uint64_t static_value2 = 0x91dae673b47ae3feULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_rviz_plugins/PictogramArray";
  }

  static const char* value(const ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
Pictogram[] pictograms\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: jsk_rviz_plugins/Pictogram\n\
Header header\n\
geometry_msgs/Pose pose\n\
uint8 ADD=0\n\
uint8 DELETE=1\n\
uint8 ROTATE_Z=2\n\
uint8 ROTATE_Y=3\n\
uint8 ROTATE_X=4\n\
uint8 JUMP=5\n\
uint8 JUMP_ONCE=6\n\
uint8 action\n\
\n\
uint8 PICTOGRAM_MODE=0 \n\
uint8 STRING_MODE=1\n\
\n\
uint8 mode\n\
string character\n\
float64 size\n\
float64 ttl\n\
float64 speed\n\
std_msgs/ColorRGBA color\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: std_msgs/ColorRGBA\n\
float32 r\n\
float32 g\n\
float32 b\n\
float32 a\n\
";
  }

  static const char* value(const ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.pictograms);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PictogramArray_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_rviz_plugins::PictogramArray_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "pictograms[]" << std::endl;
    for (size_t i = 0; i < v.pictograms.size(); ++i)
    {
      s << indent << "  pictograms[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::jsk_rviz_plugins::Pictogram_<ContainerAllocator> >::stream(s, indent + "    ", v.pictograms[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_RVIZ_PLUGINS_MESSAGE_PICTOGRAMARRAY_H
